'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PathLine = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isCollinear = function isCollinear(p1, p2, p3) {
    return (p1.y - p2.y) * (p1.x - p3.x) == (p1.y - p3.y) * (p1.x - p2.x);
};

var moveTo = function moveTo(b, a, r) {
    var vector = { x: b.x - a.x, y: b.y - a.y };
    var length = Math.sqrt(vector.x * vector.x + vector.y * vector.y);
    var unitVector = { x: vector.x / length, y: vector.y / length };
    return { x: a.x + unitVector.x * r, y: a.y + unitVector.y * r };
};

var PathLine = exports.PathLine = _react2.default.createClass({
    displayName: 'PathLine',

    render: function render() {
        var r = this.props.r;
        var path = this.props.points.slice(1).reduce(function (acc, p, i, points) {
            var next = points[i + 1];
            var prev = acc[acc.length - 1];

            if (next && !isCollinear(prev.point, p, next)) {
                var before = moveTo(prev.point, p, r);
                var after = moveTo(next, p, r);
                return acc.concat({
                    point: p,
                    s: 'L ' + before.x + ' ' + before.y + ' S ' + p.x + ' ' + p.y + ' ' + after.x + ' ' + after.y + ' '
                });
            } else {
                return acc.concat({
                    point: p,
                    s: 'L ' + p.x + ' ' + p.y + ' '
                });
            };
        }, [{
            point: this.props.points[0],
            s: 'M ' + this.props.points[0].x + ' ' + this.props.points[0].y + ' '
        }]).map(function (p) {
            return p.s;
        }).join();
        return _react2.default.createElement('path', {
            d: path,
            stroke: this.props.stroke,
            strokeWidth: this.props.strokeWidth,
            fill: this.props.fill
        });
    }
});
